<?php

/*
 * Confixx Identity Management
 *
 * Add / remove Identities (email) of user accounts to use all email adresses
 *
 * @version 0.1
 * @author Christian John
 * @website http://www.mmstudio-john.de
 */
class keyhelp_identities extends rcube_plugin
{
  
  function init()
  {
    $this->add_hook('login_after', array($this, 'login_after'));
    $this->add_hook('config_get',array($this,'config_get'));
  }

  function login_after($args)
  {
/* 
 * After login we use the session data to identitfy the user
 * 
 * user_id
 * username
 *     
 * 
 * Notice: If we logged in, we have at least one user in database and should have also one entry in identities
 * 
 */
     // declaration
     $confixx_emails = array();
     $rc_emails      = array();


     // get all keyhelp email adresses of email user
     $dbh  = rcmail::get_instance()->get_dbh(); 
     $sql_result = $dbh->query(' SELECT CONCAT (source) as email FROM keyhelp.mail_aliases  WHERE destination=?', strtolower($_SESSION['username']) );
     if($dbh->num_rows()>0)
     {
       while($sql_arr = $dbh->fetch_array($sql_result))
       {
          $keyhelp_emails[] = $sql_arr[0];
       }
     }

     // well now we have all email adresses / aliases of the user
     // we should try to get all existing identities of the user
     $sql_result = $dbh->query('SELECT identity_id, email FROM identities WHERE user_id = ?', $_SESSION['user_id']);
     // go through the result 
     // check agains keyhelp-emails if there are 
     // - some deletetd identities (missing in keyhelp DB)
     // if not remember for comparison

     while($sql_arr = $dbh->fetch_array($sql_result))
     {
       if(!in_array($sql_arr[1], $keyhelp_emails))
         $dbh->query('DELETE FROM identities WHERE identity_id=?', $sql_arr[0]);
       else
         $rc_emails[] = $sql_arr[1];
     }
 
     $insert_emails = array_diff($keyhelp_emails, $rc_emails);
     // Insert missing emails to identities
     foreach($insert_emails as $user_email)
     {
       $dbh->query( 'INSERT INTO identities 
                         (user_id, del, standard, name, email) 
                     VALUES 
                         (?, 0, 0, ?, ?)', $_SESSION['user_id'], $user_email, $user_email );
     }
    return $args;
  }

  function config_get($args){
	// Prohibit to add or remove identities. Override the config. Use the automatism.
        if ($args['name'] == 'identities_level') {
	    // 3 - one identity with possibility to edit all params but not email address
	    $args['result']=3;
        }
	return $args;
  }


}
